package Dizi;

public class Yigin {

    private int kapasite;
    private int dizi[];
    private int elemanSayisi;

    // Yapıcı yordam 100 kapasiteli Yigin Oluşturur.
    public Yigin() {
        this(100);
    }

    // Yapıcı Yordam verilen kapasitede Yigin Oluşturur.
    public Yigin(int kapasite) {
        this.kapasite = kapasite;
        dizi = new int[kapasite];
        elemanSayisi = 0;
    }

    public boolean bosmu() {
        if (elemanSayisi == 0) {
            return true;
        } else {
            return false;
        }
    }

    public boolean dolumu() {
        if (elemanSayisi == kapasite - 1) {
            return true;
        } else {
            return false;
        }
    }

    // Yığının üstüne yine bir eleman koy
    // Başarılı ise 0 başarısız ise -1 döndürür.
    public int koy(int eleman) {
        if (dolumu()) {
            System.out.println("HATA: Yığın dolu.");
            return -1;
        }

        dizi[elemanSayisi] = eleman;
        elemanSayisi++;

        return 0;
    }

    // Yığının en üstündeki sayıyı döndürür
    // Yığın boşsa, -1 döndürür
    public int ust() {
        if (bosmu()) {
            // Yığın başsa hata dönder
            System.out.println("HATA: Yığın boş");
            return -1;
        }

        return dizi[elemanSayisi - 1];
    }

    // En üsteki elemanı dönder.
    // Yığın boşsa -1 dönder.
    public int al() {
        if (bosmu()) {
            // Yığın boşsa hata dönder
            System.out.println("HATA: Yığın boş");
            return -1;
        }

        elemanSayisi--;         // elemanı sil

        return dizi[elemanSayisi];
    }
}
