package kuyruk.Dizi;

public class Kuyruk_Dizi {

    private int N = 100;
    private int[] k;    // kuyruk elemanlarını tutan dizi
    private int on;      // kuyruğun başı
    private int arka;    // kuyruğun sonu
    private int elemanSayisi; // kuyruktaki eleman sayısı

    public Kuyruk_Dizi() {
        on = arka = elemanSayisi = 0;
        k = new int[N];
    }

    public boolean bosmu() {
        return elemanSayisi == 0;
    }

    public boolean dolumu() {
        return elemanSayisi == 100;
    }

    public int ekle(int yeni) {
        if (dolumu()) {
            System.out.println("Kuyruk dolu.");
            return -1;
        }

        k[arka] = yeni;   // Yeni elemanı sona koy
        arka++;
        if (arka == N) {
            arka = 0;
        }
        elemanSayisi++;

        return 0;

    }

    public int cikart() {
        int id = -1;

        if (bosmu()) {
            System.out.println("Kuyruk boş");
            return -1;
        }

        id = on;   // ilk elemanın olduğu yer
        on++;
        if (on == N) {
            on = 0;
        }
        elemanSayisi--;

        return k[id];  // elemanı döndür

    }

    public int elemanSayisi() {
        return elemanSayisi;
    }
}
